package com.bjsxt.commons;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.ResourceBundle;

/**
 * JDBC工具类
 */
public class JdbcUtils {
    private static String driver;
    private static String url;
    private static String username;
    private static String password;
    //static块，用来初始化数据库驱动
    static {
        //读取数据库内容 文件的名字不加扩展名
        try {
        ResourceBundle bundle = ResourceBundle.getBundle("db");
        //用resourceBundle对象从properties文件中把几个key读取出来赋值给静态的成员变量
        driver = bundle.getString("jdbc.driver");
        url = bundle.getString("jdbc.url");
        username = bundle.getString("jdbc.username");
        password = bundle.getString("jdbc.password");
        //加载数据库驱动
        Class.forName(driver);   //forName有异常,try-catch
        } catch (ClassNotFoundException e) {
                e.printStackTrace();
        }
    }
    //获取连接方法  有返回值  无参
    public static Connection getConnection(){
        Connection conn = null;
        try {
            conn = DriverManager.getConnection(url,username,password);
        }catch (Exception e){
            e.printStackTrace();
        }
        return conn;
    }
    //关闭连接方法  无返回值 有参数
    public static void closeConnection(Connection conn){
        try {
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    //事务回滚处理异常
    public static void rollbackConnection(Connection conn){
        try {
            conn.rollback();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }
}
