package com.bjsxt.service.impl;

import com.bjsxt.dao.UserLoginDao;
import com.bjsxt.dao.impl.UserLoginDaoImpl;
import com.bjsxt.exception.UserNotFoundException;
import com.bjsxt.pojo.Users;
import com.bjsxt.service.UserLoginService;

/**
 * 接口实现类
 * 用户登录业务  业务层
 */
public class UserLoginServiceImpl implements UserLoginService {
    /**
     * 用户登录
     * @param username
     * @param userpwd
     * @return
     */
    @Override
    public Users UserLogin(String username, String userpwd) {
        //创建，实例化持久层对象，拿着用户名和密码在数据库中查询
        UserLoginDao userLoginDao = new UserLoginDaoImpl();
        //返回一个users
        Users users = userLoginDao.selectUserNameAndUserPwd(username, userpwd);
        //通过判断返回的users为不为空来判断用户有没有查到
        if (users == null){
            //通知servlet 在exception中创建异常类
            throw new UserNotFoundException("用户名或密码有误!");
        }
        //如果查询到了直接返回users
        return users;
    }
}
