package com.bjsxt.web.filter;

import com.bjsxt.commons.Constants;
import com.bjsxt.pojo.Users;

import javax.servlet.*;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.io.IOException;

/**
 * 判断当前客户端浏览器是否登录的filter
 */
@WebFilter({"*.do","*.jsp"})
public class UserLoginFilter implements Filter {
    @Override
    public void init(FilterConfig filterConfig) throws ServletException {

    }

    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws IOException, ServletException {
        //先获取用户请求的URI  将ServletRequest强转为子接口
        HttpServletRequest request =(HttpServletRequest)servletRequest;
        StringBuffer uri = request.getRequestURL();
        //判断当前请求的是否是login.jsp或者login.do,如果是用户登录的资源需要放行;;验证码也属于login.jsp中的，所以也需要放行
        if (uri.indexOf("login.jsp") != -1 ||uri.indexOf("login.do") != -1 ||uri.indexOf("validateCode.do") != -1){
            filterChain.doFilter(servletRequest, servletResponse);
        }else {
            //从客户端浏览器的请求中获取所对应的session
            HttpSession session = request.getSession();
            //从session中取users对象  UserLoginServler中将users对象放进了session中
            Users users = (Users)session.getAttribute(Constants.USER_SESSION_KEY);
            if (users != null){
                //说明登录过了  可以放行
                filterChain.doFilter(servletRequest, servletResponse);
            }else{
                //users为空，提示信息，跳转到登录页面
                request.setAttribute(Constants.REQUEST_MSG,"请登录！");
                request.getRequestDispatcher("login.jsp").forward(servletRequest, servletResponse);
            }
        }
    }

    @Override
    public void destroy() {

    }
}
