package com.bjsxt.web.listener;

import com.bjsxt.commons.Constants;
import com.bjsxt.pojo.Users;

import javax.servlet.ServletContext;
import javax.servlet.annotation.WebListener;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;
/**
 * 解决Httpsession被反复销毁的问题
 */

@WebListener
public class HttpSessionLifecycleListener implements HttpSessionListener {
    @Override
    public void sessionCreated(HttpSessionEvent se) {

    }

    @Override
    public void sessionDestroyed(HttpSessionEvent se) {
        //获取servletContext对象，然后将所对应的Httpsession删除掉
        HttpSession session= se.getSession();
        ServletContext servletContext = session.getServletContext();
        //从session中将所缓存的user对象取出来
        Users users = (Users)session.getAttribute(Constants.USER_SESSION_KEY);
        //通过userID将session删除
        servletContext.removeAttribute(users.getUserid()+"");
    }
}
